package com.dkha.common.enums;

/**
 * 就业渠道
 */
public enum EmployeeChannel {

    NEARBY("1", "就近就地就业"),
    ACROSS("2", "疆内跨地州就业"),
    INLAND("3", "内地省市就业"),
    CORPS("4", "兵团就业"),
    TRANSFER("5", "有组织转移就业"),

    SMALLBUSINESS("6", "“十小”服务业"),

    PARK("7", "园区企业就业"),
    SPIN("8", "纺织服装产业就业"),
    ELECTRONIC("9", "电子装配、假发、玩具等部分劳动密集型就业"),
    VILLAGE_WORKSHOP("10", "乡村生产车间就业就业"),
    TOURISM_SERVICE("11", "旅游服务就业"),
    FIXED_INVESTMENT("12", "固定资产投资项目建设领域就业");

    public String code;
    public String name;

    EmployeeChannel(String code, String name) {
        this.code = code;
        this.name = name;
    }

    public static EmployeeChannel getByCode(String code) {
        for(EmployeeChannel employeeChannel : EmployeeChannel.values()){
            if(code.equals(employeeChannel.code)){
                return employeeChannel;
            }
        }
        return  null;
    }
}
