package com.dkha.common.modules.vo.camera;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.tomcat.jni.Library;

import java.util.List;
import java.util.Map;

/**
 * @version V1.0
 * @Description: TODO(人物轨迹中redis存储单个摄像头分组信息)
 * All rights 成都电科慧安
 * @Title: BayOnetCameraVO
 * @Package com.dkha.common.modules.vo.camera
 * @author: panhui
 * @date: 2020/1/9 17:38
 * @Copyright: 成都电科慧安
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
@ApiModel(value="人物轨迹数据", description="人物轨迹中redis存储单个摄像头分组信息")
public class BayOnetCameraVO {

    @ApiModelProperty(value = "摄像头id")
    private String cameraId;

    @ApiModelProperty(value = "关联库id")
    private String associationLibraryId;

//    @ApiModelProperty(value = "关联的人物数据")
//    private PeopleVO peopleVO;

    @ApiModelProperty(value = "处理抓拍条数")
    public Long warningNum = 0L;

    @ApiModelProperty(value = "关于人脸的featids")
    private List<String> featIds;
//    @ApiModelProperty(value = "关联任务信息预警的id,人脸特征id-》不同的预警id信息")
//    private List<AssociationPeopleVO> associationPeople;

}
