package com.dkha.common.modules.vo.search;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @Author Spring
 * @Since 2019/12/10 15:07
 * @Description 人脸库检索返回数据
 */
@Data
public class SearchPortraitVo implements Comparable<SearchPortraitVo>{

    @ApiModelProperty(value = "人脸Id")
    private String idPortrait;

    @ApiModelProperty(value = "姓名")
    private String name;

    @ApiModelProperty(value = "性别")
    private String sex;

    @ApiModelProperty(value = "身份证号码")
    private String idCard;

    @ApiModelProperty(value = "相似度")
    private Double similarityDegree = new Double(0L);

    @ApiModelProperty(value = "库Id")
    private String idLibrary;

    @ApiModelProperty(value = "库名称/来源")
    private String libraryName;

    @ApiModelProperty(value = "人脸图片")
    private String url;

    @Override
    public int compareTo(SearchPortraitVo o) {
        return o.getSimilarityDegree().compareTo(this.getSimilarityDegree());
    }
}
