package com.dkha.common.modules.vo.warning;


import com.dkha.common.modules.vo.position.FaceVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.annotation.Id;

import java.util.List;

/**
 * @version V1.0
 * @Description: 预警信息
 * All rights 成都电科慧安
 * @Title: WarningVO
 * @Package com.dkha.common.entity.vo.warning
 * @author: panhui
 * @date: 2019/11/27 9:49
 * @Copyright: 成都电科慧安
 */
@AllArgsConstructor
@NoArgsConstructor
@Data
//@JsonInclude(JsonInclude.Include.NON_NULL)
@ApiModel(value="预警", description="用于和底层传输统一参数格式")
public class WarningVO {
    @ApiModelProperty(value = "报警唯一id")
    @Id
//    @Field(type= FieldType.Keyword)
    private String id;
    @ApiModelProperty(value="时间戳用来排序")
    private Long timestamp;
    @ApiModelProperty(value = "消息日期")
    private String date;
    @ApiModelProperty(value = "任务id")
    private String taskIdCameraId;//task_id_ph_0001
    @ApiModelProperty(value = "api端任务id")
    private String taskId;//task_id_ph
    @ApiModelProperty(value = "摄像头id")
    private String cameraId;//0001
    @ApiModelProperty(value = "背景图片")
    private String bgImg;
    @ApiModelProperty(value = "背景高度")
    private Integer bgHeight;
    @ApiModelProperty(value = "背景宽度")
    private Integer bgWidth;
    @ApiModelProperty(value = "人脸坐标列表")
    private List<FaceVO> faces;

}
