package com.dkha.server.annotation;

import java.lang.annotation.*;
import java.util.concurrent.TimeUnit;

/**
 * @version V1.0
 * @Description: 对需要防止重复提交的页面添加该注解
 * @Title: 防止重复提交
 * @author: huangyugang
 * @date: 2019/12/23 13:58
 * @Copyright: 成都电科慧安
 */
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
@Documented
public @interface NoRepeatSubmitAnnotation {
    /** key前缀 */
    String prefix() default "";

    /** 过期秒数,默认为5秒 */
    int expire() default 5;

    /** 超时时间单位，默认为秒 */
    TimeUnit timeUnit() default TimeUnit.SECONDS;

    /** Key的分隔符（默认 :）  */
    String delimiter() default ":";
}
