package com.dkha.server.modules.entities;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import java.sql.Time;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 人像预警表
 * </p>
 *
 * @author Spring
 * @since 2019-12-09
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="face_information对象", description="人像预警表")
public class FaceInformation implements Serializable {
    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "时间")
    private String time;
    @ApiModelProperty(value = "视频解帧大图地址")
    private String jzphoto;
    @ApiModelProperty(value = "原始待人脸地址")
    private String cphoto;
    @ApiModelProperty(value = "比对最相似的人脸地址")
    private String rphoto;
    @ApiModelProperty(value = "比对相似度")
    private double xsd;
    @ApiModelProperty(value = "姓名")
    private String name;
    @ApiModelProperty(value = "库名称")
    @TableField("libname")
    private String libName;
    @ApiModelProperty(value = "摄像头id")
    @TableField("cameraId")
    private String cameraId;
    @ApiModelProperty(value = "摄像头地址")
    @TableField("rtspUrl")
    private String rtspUrl;
}
