package com.dkha.server.modules.entities;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;


/**
 * <p>
 * 库表
 * </p>
 *
 * @author Spring
 * @since 2019-12-09
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="FaceLibrary对象", description="库表")
public class FaceLibrary implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "id")
    @TableId(value = "id_factory")
    private Long idFactory;

    @ApiModelProperty(value = "库名称")
    private String factoryName;

    @ApiModelProperty(value = "库类型-码值")
    private String factoryType;

    @ApiModelProperty(value = "备注信息")
    protected String remarks;

    @TableField(exist = false)
    @ApiModelProperty(value = "图片数量")
    private String number;

    @TableField(exist = false)
    @ApiModelProperty(value = "类型名称")
    private String factoryTypeName;

    @ApiModelProperty(value = "是否有效 Y有效 N无效")
    private String isValid;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "创建人")
    private String createBy;

    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    @ApiModelProperty(value = "更新人")
    private String updateBy;


}
