package com.dkha.server.modules.entities.faceCamera;

import com.dkha.common.util.UtilValidate;
import com.dkha.server.system.modules.sys.entity.SysDictDataEntity;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.apache.commons.lang3.StringUtils;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

//@Data
@ApiModel(description = "查看摄像头信息")
@Getter
@Setter
@NoArgsConstructor
public class FaceCameraInfo {

    @ApiModelProperty(value = "idFaceCamera")
    private Long idFaceCamera;
    @NotBlank(message = "摄像头名称不能为空")
    @ApiModelProperty(value = "摄像头名称")
    private String cameraName;

    @ApiModelProperty(value = "摄像头区域-码值")
    private String cameraRegionFirstlevel;

    public String getCameraRegionFirstlevel() {
        if (UtilValidate.isNotEmpty(cameraRegionFirstlevel)) {
            return cameraRegionFirstlevel;
        }

        return StringUtils.join(cameraRegionFirstlevelArrays, ',');
    }

    @ApiModelProperty(value = "摄像头层级区域冗余字段")
    private String cameraRegionFirstlevelBackUp;
    @NotNull(message = "摄像头区域不能为空")
    @ApiModelProperty(value = "摄像头区域-码值")
    private String[] cameraRegionFirstlevelArrays;

    public String[] getCameraRegionFirstlevelArrays() {
        if (UtilValidate.isNotEmpty(this.cameraRegionFirstlevelArrays)) {
            return this.cameraRegionFirstlevelArrays;
        }

        return this.cameraRegionFirstlevel.split(",");
    }


    @ApiModelProperty(value = "摄像头详细地址")
    private String cameraAddress;

    @NotBlank(message = "摄像头经度不能为空")
    @Min(value = -180,message = "经度不能小于-180")
    @Max(value = 180,message = "经度不能大于180")
    @ApiModelProperty(value = "摄像头经度")
    private String cameraLongitude;

    @NotBlank(message = "摄像头纬度不能为空")
    @ApiModelProperty(value = "摄像头纬度")
    @Min(value = -90,message = "纬度不能小于-90")
    @Max(value = 90,message = "纬度不能大于90")
    private String cameraLatitude;
//    @NotBlank(message = "位置类型不能为空")
//    @ApiModelProperty(value = "位置类型-码值")
//    private String cameratLocationtypeId;

    //    @ApiModelProperty(value = "公安机关代码")
//    private String publicSecurityCode;
//
//    @ApiModelProperty(value = "公安机关名称")
//    private String publicSecurityName;
    @NotBlank(message = "型号不能为空")
    @ApiModelProperty(value = "型号")
    private String version;

    @ApiModelProperty(value = "品牌id")
    private String idBrand;

    //    @ApiModelProperty(value = "建设单位")
//    private String constructionUnit;
//
//    @ApiModelProperty(value = "管理单位")
//    private String managementUnit;
//
//    @ApiModelProperty(value = "管理人员")
//    private String managementPersonnel;
//
//    @ApiModelProperty(value = "联系电话")
//    private String contactNumber;
//    @NotBlank(message = "ip不能为空")

//    @NotBlank(message = "port不能为空")
    @ApiModelProperty(value = "端口")
    private String port;

    @ApiModelProperty(value = "IP")
    private String ip;
//    @NotBlank(message = "用户名不能为空")

    @ApiModelProperty(value = "用户名")
    private String userName;
//    @NotBlank(message = "密码不能为空")

    @ApiModelProperty(value = "密码")
    private String passwd;
    @NotBlank(message = "品牌不能为空")

    @ApiModelProperty(value = "品牌")
    private String brand;
    @NotBlank(message = "rtsp地址不能为空")

    @ApiModelProperty(value = "rtsp地址")
    private String rtspUrl;

    @ApiModelProperty(value = "备注信息")
    private String remarks;

    @ApiModelProperty(value = "是否运行 Y启动 N未启动")
    private String status;

}
