package com.dkha.server.services;




import com.baomidou.mybatisplus.extension.service.IService;
import com.dkha.common.modules.vo.face.FaceTrackVO;
import com.dkha.server.modules.entities.FaceTrackEntity;

import java.util.List;

/**
 * 
 *
 * @author Mark sunlightcs@gmail.com
 * @since 1.0.0 2020-01-10
 */
public interface FaceTrackService extends IService<FaceTrackEntity> {
    /**
     * 新增
     * @param faceTrackEntity
     * @return
     */
    int addFaceTrackEntity(FaceTrackEntity faceTrackEntity);
    /**
     * 根据摄像头和分组时间查询
     * @param idFaceCamera
     * @param packetTime
     * @return
     */
    List<FaceTrackEntity> querByidCameraAndTime(Long idFaceCamera, String packetTime);

    /**
     * 根据摄像头Id和开始，结束时间，人脸ID
     * @param faceTrackVO
     * @return
     */
    List<FaceTrackEntity> queryByidCamerAndFaceId(FaceTrackVO faceTrackVO);

    /**
     * 根据图片路径和开始，结束时间
     * @param faceTrackVO
     * @return
     */
    List<FaceTrackEntity> queryByurlAndTime(FaceTrackVO faceTrackVO);

    /**
     * 根據時間獲取庫id
     * @param faceTrackVO
     * @return
     */
    List<String> findIdFatoryByTime(FaceTrackVO faceTrackVO);

    /**
     * 根据图片路径和开始，结束时间和阈值
     * @param faceTrackVO
     * @return
     */
    List<FaceTrackEntity> queryBytrajectoryThreshold(FaceTrackVO faceTrackVO);
    /**
     * 根据人脸ID查询
     * @param idPortrait
     * @return
     */
    FaceTrackEntity queryByIdPortrait(String idPortrait);

    List<FaceTrackEntity> findTrackByFaceId(List<String> faceIds);
}