package com.dkha.server.services;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.dkha.common.modules.vo.control.TaskControlVO;
import com.dkha.common.modules.vo.control.VideoControlVo;
import com.dkha.common.page.PageParam;
import com.dkha.common.result.CommonResult;
import com.dkha.server.modules.entities.ControlTask;
import com.baomidou.mybatisplus.extension.service.IService;
import org.springframework.web.multipart.MultipartFile;

/**
 * <p>
 * 布控任务 服务类
 * </p>
 *
 * @author Spring
 * @since 2019-12-09
 */
public interface IControlTaskService extends IService<ControlTask> {

    /**查询任务列表*/
    Page<ControlTask> getList(PageParam pageParam,Integer videotype);
    /**添加任务列表*/
    CommonResult addControlTask(TaskControlVO controlTask);
    /**修改任务*/
    CommonResult updateControlTask(TaskControlVO controlTask);
    /**删除指定任务*/
    CommonResult deleteControlTask(String taskID);
    /**根据任务ID获取摄像头列表*/
    CommonResult getCameraListByTaskID(String taskID);
    /**根据任务Num获取摄像头列表*/
    CommonResult getCameraListByTaskNO(String taskNO);
    /**根据任务ID停止任务*/
    CommonResult stopControlByTaskID(String taskID);
    /**根据任务ID暂停任务*/
    CommonResult suspendControlByTaskID(String taskID);
    /**根据任务ID恢复任务*/
    CommonResult resumeControlByTaskID(String taskID);
    /**人脸信息添加*/
    CommonResult addtaskfaceFile(MultipartFile multipartFile);
    /**人脸信息添加base64*/
    CommonResult addtaskfaceFiles(String url);
    /**添加视频文件*/
    CommonResult addcomplevideoFile(MultipartFile multipartFile);
    /**添加视频比对任务*/
    CommonResult addcomplevideoTask(VideoControlVo controlVO);
    /**根据摄像头的区域ID列表转换为区域字符串*/
    String getCameraRegionStringByRegionstr(String Regionstr);
    /**根据任务ID获取库字符串*/
    String getLibRegionBytaskid(String taskID);
    /**根据摄像头id获取任务信息*/
    ControlTask getTaskInfoByCameraID(String Camera);
}
