/**
 * Copyright (c) 2018 人人开源 All rights reserved.
 * <p>
 * https://www.renren.io
 * <p>
 * 版权所有，侵权必究！
 */

package com.dkha.server.system.modules.sys.dto;

import com.dkha.server.system.common.validator.group.AddGroup;
import com.dkha.server.system.common.validator.group.DefaultGroup;
import com.dkha.server.system.common.validator.group.UpdateGroup;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Null;
import java.io.Serializable;
import java.util.Date;

/**
 * 字典数据
 *
 * @author Mark sunlightcs@gmail.com
 */
@Data
@ApiModel(value = "字典数据")
public class SysDictDTO implements Serializable {
    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "父id")
    private Long pid;

    @ApiModelProperty(value = "码表值类型ID")
    @NotNull(message = "码表值类型ID不能为空")
    private String dictType;

    @ApiModelProperty(value = "码表名称")
    @NotBlank(message = "码表名称不能为空")
    private String dictName;
//    @NotBlank(message = "码表值不能为空")
//    @ApiModelProperty(value = "码表值")
//    private String dictValue;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "排序")
    private Integer sort;

}