package com.dkha.task.modual.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 摄像头表
 * </p>
 *
 * @author Spring
 * @since 2019-12-09
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="FaceCamera对象", description="摄像头表")
public class FaceCamera implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "id")
    @TableId(value = "id_face_camera", type = IdType.ID_WORKER)
    private Long idFaceCamera;

    @ApiModelProperty(value = "摄像头名称")
    private String cameraName;

    @ApiModelProperty(value = "摄像头区域-码值")
    private String cameraRegionFirstlevel;

    @ApiModelProperty(value = "摄像头详细地址")
    private String cameraAddress;

    @ApiModelProperty(value = "摄像头经度")
    private String cameratLongitude;

    @ApiModelProperty(value = "摄像头纬度")
    private String cameraLatitude;

    @ApiModelProperty(value = "位置类型-码值")
    private String cameratLocationtypeId;

    @ApiModelProperty(value = "公安机关代码")
    private String publicSecurityCode;

    @ApiModelProperty(value = "公安机关名称")
    private String publicSecurityName;

    @ApiModelProperty(value = "建设单位")
    private String constructionUnit;

    @ApiModelProperty(value = "管理单位")
    private String managementUnit;

    @ApiModelProperty(value = "管理人员")
    private String managementPersonnel;

    @ApiModelProperty(value = "联系电话")
    private String contactNumber;

    @ApiModelProperty(value = "IP")
    private String ip;

    @ApiModelProperty(value = "用户名")
    private String userName;

    @ApiModelProperty(value = "密码")
    private String passwd;

    @ApiModelProperty(value = "品牌")
    private String brand;

    @ApiModelProperty(value = "rtsp地址")
    private String rtspUrl;

    @ApiModelProperty(value = "备注信息")
    private String remarks;

    @ApiModelProperty(value = "是否运行 Y启动 N未启动")
    private String status;

    @ApiModelProperty(value = "是否有效 Y有效 N无效")
    private String isValid;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    @ApiModelProperty(value = "创建人")
    private String createBy;

    @ApiModelProperty(value = "更新人")
    private String updateBy;


}
