package com.dkha.task.modual.mapper;



import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.dkha.task.modual.entity.FaceTrackEntity;
import com.dkha.task.modual.vo.FaceTrackVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 
 *
 * @author Mark sunlightcs@gmail.com
 * @since 1.0.0 2020-01-10
 */
@Mapper
public interface FaceTrackMapper extends BaseMapper<FaceTrackEntity> {
    /**
     * 根据摄像头和分组时间查询
     * @param idFaceCamera
     * @param packetTime
     * @return
     */
   List<FaceTrackEntity> querByidCameraAndTime(@Param("idFaceCamera")Long idFaceCamera, @Param("packetTime")String  packetTime);
    /**
     * 根据摄像头Id和开始，结束时间，人脸ID
     * @param faceTrackVO
     * @return
     */
    List<FaceTrackEntity> queryByidCamerAndFaceId(@Param("faceTrackVO")FaceTrackVO faceTrackVO);

    /**
     * 根据图片路径和开始，结束时间
     * @param faceTrackVO
     * @return
     */
    List<FaceTrackEntity> queryByurlAndTime(@Param("faceTrackVO")FaceTrackVO faceTrackVO);
}